<template lang="pug">
div
  h1 Case 1
</template>
    
    
    
    <script lang="js">
    
    import { useDevice, useMapper ,useGlobalSettings} from '@bitaffair/vue-streamdeck';
  
    
    import { ref, defineComponent, computed, unref } from 'vue';
    
    
  
    
    export default {
      setup() {
    
        const appMapper = useMapper('app-home', {
          defaultMapping: {
            'A': 0,
            'B': 1
          }
        });
    
        const devicePointerA = appMapper.serial('A')
    
    
        const huhu = ref('huhu');
        setInterval(() => huhu.value = Math.random(), 1000);
    
        const arr = new Array(32).fill(0);
    
        const layout = ref({
          keys: arr.reduce((acc, _, index) => {
    
            let toggleState = false;
    
            acc[index] = {
    
              events: {
                down({ key, state }) {
    
                  this.setKeyState(key, 'pressed');
    
                  setTimeout(() => {
                    toggleState = !toggleState;
    
                    //	this.setKeyState(key, toggleState ? 'active' : 'default');
    
                  }, 100);
    
    
    
    
                },
                up: ({ key, state }) => {
                  device.setKeyState(key, state === 'default' ? 'active' : 'default');
                }
              },
    
              views: {
                default: {
                  index: 1500 + index,
                  label: 'B' + String(index + 1).padStart(3, '0'),
                  color: 'white',
                  backgroundColor: 'purple'
                },
                pressed: {
                  index: 1500 + index,
                  label: 'C' + String(index + 1).padStart(3, '0'),
                  color: 'purple',
                  backgroundColor: 'white'
                },
                active: {
                  index: 1500 + index,
                  label: 'C' + String(index + 1).padStart(3, '0'),
                  color: 'purple',
                  backgroundColor: 'orange'
                }
              }
    
            };
    
            return acc;
          }, {})
        });
    
    
        const device = useDevice(devicePointerA, { layout, exclusive: true });
    
    
        layout.value.keys[0].views.default.label = huhu;
    
    
        const colors = ['red', 'green', 'skyblue', 'blue'];
        let colorIndex = 0;
        setInterval(() => {
    
          const keyIndex = Math.floor(Math.random() * 32);
    
          layout.value.keys[keyIndex].views.default.backgroundColor = colors[colorIndex]
          colorIndex++
    
          layout.value.keys[keyIndex].views.default.label = Math.round((Math.random() * 100000))
    
          if (colorIndex >= colors.length) {
            colorIndex = 0;
          }
    
        }, 1000);
    
    
    
    
        return {
          device
        }
      }
    }
    
    </script>